# MWSE Nedir?

MWSE yani Micro Web Socket Engine, kendisine bağlanan eşleri birbirlerini ile eşleştirerek, eşler arası veri tüneli oluşturur.

Bağlantı TCP tabanlı yüksek hızlı WebSocket protokolüne dayanır ve sunucunun cihazları sanallaştırması sayesinde diğer kişilerin IP adreslerini veya cihaz türü gibi bilgilere ihtiyaç duymadan çift taraflı iletişim kurmalarını sağlar.

## WebSocket topolojisi

![image](https://www.hitechmv.com/wp-content/uploads/2014/05/startopology.jpg)

## Proje tarafından uygulanan load balance teknolojisi

![image](https://git.saqut.com/saqut/storage/raw/branch/master/Diagram1.png)

## Kavramlar

- `Prealpha` : Diğer gerekliliklere bağlı olarak geliştirilen üzerine arge yapılan işlev
- `Alpha` : Gereksinimleri tamamlayan henüz olgunluğa ulaşmamış işlevler
- `Beta` : Tam olarak gereken işlemleri tamamlayan ancak optimizasyon veya üzerinde değişiklik yapılması gereken işlemler
- `Stable` : Tüm gereklilikleri sağlayan yayınlanmaya hazır olan işlemler
- `LTS Stable` : Sonraki stabil sürüm yayınlanıncaya kadar alt yapısının desteği sağlanacak olan sürüm
- `Unpublish/Remove Release` : Eski sürümlerin artık desteğinin ve alt yapısının yayından kaldırılması.

## Sürüm Yükseltme mantığı

Herhangi bir sürüm, bulunduğu sürüm ile eşleşen tüm sorunlar giderildiğinde, geliştirmeler tamamlandığında ve alt yapısı hazırlandıktan sonra bir sonraki sürüme yükseltilir.

Bir sonraki sürümün içeriği ve ne zaman biteceği  bir önceki sürümün `Beta` versiyonunda belirlenir

# MWSE Versiyon Dağılımı
```
V1 Prealpha ---> Alpha ----> Beta --->  Stable ---> LTS Stable
V2 ----------------------------------> Next version Planning
V2 Prealpha ---> Alpha ----> Beta --->  Stable ---> LTS Stable
V3 ------------------------> Next version Planning
V1 ------------------------> Add Deprecation warnings & adding documentation
V3 Prealpha ---> Alpha ----> Beta --->  Stable ---> LTS Stable
V1 -----------------------------------------------> Unpublish Release
```
| Stage | Name | Job | 
|-|-|-|
| 1 | V1 | Prealpha |
| 2 | V1 | Alpha |
| 3 | V1 | Beta |
| 4 | V1 | Stable |
| 5 | V2 | Next version Planning |
| 6 | V1 | LTS Stable / Publish Release |
| 7 | V2 | Prealpha |
| 8 | V2 | Alpha |
| 9 | V2 | Beta |
| 10 | V3 | Next version Planning |
| 11 | V1 | Add Deprecation warnings & adding documentation |
| 12 | V2 | LTS Stable / Publish Release |
| 13 | V3 | Prealpha |
| 14 | V3 | Alpha |
| 15 | V3 | Beta |
| 16 | v2 | Add Deprecation warnings & adding documentation |
| 17 | V3 | Stable |
| 18 | V1 | Unpublish/Remove Release |
| 19 | V3 | LTS Stable / Publish Release |
| 20 | V3 | Finish Project |
---

# Versiyon 1.0

## Prealpha yayının bitişi

- [x] WebSocket bağlantısı ve başarılı client kurulumu
- [x] TLS yapılandırması ve wss yönlendirme
- [x] Client UUID Hashing ve socket havuzu
- [x] Tek kanaldan birden çok Request/Response mantığı
- [x] Promise uyumlu / Async sunucu yapısı

## Alpha yayının bitişi

- [x] Session ve kişiye özel oturum bilgisi tutma
- [x] <s>Kayıtlı kullanıcı oturum açma ve kayıt olma</s>
- [x] Kişiler arası haberleşme
- [x] Kişileri eşleştirme ve tünelleme (kişiler arası veri aktarımı)
- [x] Oda mantığı / Odaya açma / odaya katılma / şifreli oda / herkese açık oda
- [x] Oda bildirimleri / broadcasting / kullanıcı katılma ayrılma bildirimleri

## Beta yayınının bitişi

- [x] Client taraflı typescript kütüphane yayını
    - [x] Promise yapısı
    - [x] ID bilgilendirme oryantasyonu
    - [x] Oda listeleme / açma / kapatma / katılma / davet sistemi
    - [x] Client el sıkışma / reddetme
    - [x] Cliente mesaj gönderme alma

## Stabil yayının bitişi

- [ ] Admin dashboard / veri aktarımı limiti
- [ ] Herkese açık belgelendirme

## LTS Stabil Sürüm

- [ ] Yedekleme ve loglama

---

# Planlanan Versiyon 2.0

## Prealpha yayının bitişi

- [ ] İkili veri gönderimi (Ajax ile)
- [x] Sanal kısa kod tahsisi ve servisleri
- [x] Sanal IP Tahsisi ve servisleri
- [x] Sanal Numara Tahsisi ve servisleri

## Alpha yayının bitişi

- [ ] Kullanıcı girişi kaydı ve api servisleri
- [ ] Dahili WebRTC Kütüphanesi / Görüntü ve Ses Streaming / P2P Mesajlaşma
- [ ] İki kanal WebSocket (Aktif aktarım / Pasif aktarım)
- [ ] WebRTC Streaming / Dosya akışı